﻿package  
{
	import caurina.transitions.Tweener;
	import flash.display.MovieClip;
	import flash.display.StageQuality;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import org.papervision3d.cameras.DebugCamera3D;
	import org.papervision3d.events.InteractiveScene3DEvent;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.MovieAssetMaterial;
	import org.papervision3d.materials.MovieMaterial;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.view.BasicView;
	
	public class MyBasic extends BasicView
	{
		public var sw:Number;
		public var sh:Number;
		public var frontPlane:Plane;
		public var backPlane:Plane;
		public var planeSet:DisplayObject3D;
		public var isFront:Boolean = true;
		
		public var startBtn:MovieClip;
		public var background:Background;
		public var photoNo:PhotoNumber;
		
		public var debugCamera:DebugCamera3D;
		
		public function MyBasic() 
		{
			stage.quality = StageQuality.HIGH;
			startBtn.addEventListener(MouseEvent.CLICK, init);
		}
		
		private function init(e:MouseEvent):void 
		{
			startBtn.visible = false;
			startBtn.removeEventListener(MouseEvent.CLICK, init);
			
			sw = stage.stageWidth / 2;
			sh = stage.stageHeight / 2;
			
			viewport.interactive = true;

			photoNo = new PhotoNumber();
			photoNo.addEventListener(Event.CHANGE, photoNoChangeHD);
			var front:FrontScreen = new FrontScreen(photoNo);
			var end:EndScreen = new EndScreen(photoNo);
			var frontMat:MovieMaterial = new MovieMaterial(front, true, true, true);
			var endMat:MovieMaterial = new MovieMaterial(end, true, true, true);
			frontMat.interactive = true;
			endMat.interactive = true;
			frontMat.smooth = true;
			endMat.smooth = true;
			
			frontPlane = new Plane(frontMat, 226, 330, 2, 3);
			backPlane = new Plane(endMat, 226, 330, 2, 3);
			planeSet = new DisplayObject3D();
			backPlane.rotationY = 180;
			planeSet.addChild(frontPlane);
			planeSet.addChild(backPlane);
			scene.addChild(planeSet);
			
			frontPlane.addEventListener(InteractiveScene3DEvent.OBJECT_OVER, objOverHD);
			frontPlane.addEventListener(InteractiveScene3DEvent.OBJECT_OUT, objOutHD);
			frontPlane.addEventListener(InteractiveScene3DEvent.OBJECT_CLICK, objClickHD);
			backPlane.addEventListener(InteractiveScene3DEvent.OBJECT_OVER, objOverHD);
			backPlane.addEventListener(InteractiveScene3DEvent.OBJECT_OUT, objOutHD);
			backPlane.addEventListener(InteractiveScene3DEvent.OBJECT_CLICK, objClickHD);
			
			camera.z = -550;
			camera.fov = 50;
			camera.zoom = 50;
			
			//debugCamera = new DebugCamera3D(viewport);
			
			
			startRendering();
		}
		
		private function photoNoChangeHD(e:Event):void 
		{
			background.changePhoto(photoNo.no);
		}
		
		private function objClickHD(e:InteractiveScene3DEvent):void 
		{
			isFront = !isFront;
			var targetDeg:Number = isFront ? 0 : 180;
			if (Tweener.isTweening(planeSet)) {
				Tweener.removeTweens(planeSet);
			}
			Tweener.addTween(planeSet, { 
				rotationY:targetDeg,
				time:0.6,
				transition:'easeOutQuad',
				onUpdate:flippingHD
			});
			if (isFront) {
				background.fadeOut();
			}
		}
		
		private function flippingHD():void
		{
			planeSet.z = Math.sin(planeSet.rotationY / 180 * Math.PI) * 300;
		}

		private function objOverHD(e:InteractiveScene3DEvent):void 
		{
			viewport.buttonMode = true;
		}
		
		private function objOutHD(e:InteractiveScene3DEvent):void 
		{
			viewport.buttonMode = false;
		}
		
		override protected function onRenderTick(event:Event = null):void
		{
			movePlaneSet();
			
			renderer.renderScene(scene, camera, viewport);
		}
		
		private function movePlaneSet():void
		{
			if (Tweener.isTweening(planeSet)) {
				return;
			}
			var offsetDeg:Number = isFront ? 0 : 180;
			var xfactor:Number = isFront ? 1 : -1;
			var degX:Number = (mouseY - sh) / sh * 20 * xfactor;
			var degY:Number = -(mouseX - sw) / sw * 60;
			
			planeSet.rotationX += (degX - planeSet.rotationX) * 0.1;
			planeSet.rotationY += (degY + offsetDeg - planeSet.rotationY) * 0.1;
		}
	}
	
}